function getUrlParam(curUrl, name) {
	var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)");
	var r = curUrl.substr(1).match(reg);
	if(r != null) {
		return unescape(r[2]);
	} else {
		return null;
	}
}
/**
 * 得到所有的参数和值
 * @param {Object} curUrl 当前url
 */
function getParameterByUrl(curUrl) {
	var result = new Array();
	var index = curUrl.indexOf("?");
	if(index != -1) {
		var parpmeters = curUrl.substr(1);
		strs = parpmeters.split("&");
		for(var i = 0; i < strs.length; i++) {
			var sonIndex = strs[i].indexOf("=");
			var parame = strs[i].substr(0, sonIndex);
			var value = strs[i].substr(sonIndex + 1);
			var sonArray = new Array();
			sonArray.push(parame);
			sonArray.push(value);
			result.push(sonArray);
		}
	}
	return result;
}

/**
 * 得到指定参数的值通过Url
 * @param {Object} curUrl   当前URL
 * @param {Object} param    参数
 */
function getParameterValueByUrl(curUrl, param) {
	var result;
	if(param == "") {
		return result;
	}
	var index = curUrl.indexOf("?");
	if(index != -1) {
		var parpmeters = curUrl.substr(1);
		strs = parpmeters.split("&");
		for(var i = 0; i < strs.length; i++) {
			var sonIndex = strs[i].indexOf("=");
			var parame = strs[i].substr(0, sonIndex);
			if(parame != param) {
				continue;
			} else {
				var value = strs[i].substr(sonIndex + 1);
				result = value;
				break;
			}
		}
	}
	return result;
}

/**
 * 时间格式化扩展函数
 * @param {Object} fmt 格式化字符串
 */
Date.prototype.Format = function(fmt) {
	var o = {
		"M+": this.getMonth() + 1, //月份   
		"d+": this.getDate(), //日   
		"h+": this.getHours(), //小时   
		"m+": this.getMinutes(), //分   
		"s+": this.getSeconds(), //秒   
		"q+": Math.floor((this.getMonth() + 3) / 3), //季度   
		"S": this.getMilliseconds() //毫秒   
	};
	if(/(y+)/.test(fmt)) {
		fmt = fmt.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
	}
	for(var k in o) {
		if(new RegExp("(" + k + ")").test(fmt)) {
			fmt = fmt.replace(RegExp.$1, (RegExp.$1.length == 1) ? (o[k]) : (("00" + o[k]).substr(("" + o[k]).length)));
		}
	}
	return fmt;
}

function createDownload1(server, f) {
	var p = server + 'sp/updoc/pdf/' + f;
	console.log('开始下载' + p);
	/**var val="http://192.168.1.97/sp/updoc/GB_10767-2010.pdf";*/
	var dtask = plus.downloader.createDownload(p, {}, function(d, status) {
		// 下载完成
		if(status == 200) {
			alert("下载完成: " + d.filename);
		} else {
			alert("下载失败: " + status);
		}
	});
	dtask.start();
}

function openPDF(server, f) {
	var p = server + 'sp/updoc/pdf/' + f;
	console.log('开始dakai' + p);
	plus.runtime.openFile('../doc/a.pdf');
	plus.runtime.openURL(p);
	console.log('jieshu' + p);
}

function openDir(server, fileName) {
	console.log('_downloads/' + fileName);
	plus.io.resolveLocalFileSystemURL('_downloads/' + fileName,
		function(entry) {
			if(!entry) {
				createDownload(server, fileName, true);
				return;
			}
			if(entry.isDirectory) {
				alert('不是文件');
			} else {
				setTimeout(function() {
					plus.runtime.openFile('_downloads/' + fileName, {},
						function(e) {
							plus.nativeUI.alert("无法打开此文件：" + e.emssage);
						}
					);
				}, 1000);
			}
		},
		function(e) {
			setTimeout(function() {
				createDownload(server, fileName, true);
			}, 1000);
		}
	);
}
// 创建下载任务

function createDownload(server, f, isopen) {
	var dtask = null;
	var p = encodeURI(server + 'sp/updoc/pdf/' + f);
	console.log(p);
	//有的话就不下载了
	plus.io.resolveLocalFileSystemURL('_downloads/' + f,
		function(entry) {
			if(!entry) {
				//
			} else {
				console.log('文件存在！');
				return;
			}
		},
		function(e) {}
	);

	if(dtask) {
		mui.toast('下载任务已创建！');
		return;
	}

	var options = {
		method: "GET",
		filename: f,
		retry: 1
	};
	dtask = plus.downloader.createDownload(p, options);
	console.log('ab:' + dtask + ":" + p);
	//http://192.168.1.97/sp/updoc/pdf/75f11955-dfb6-4440-8989-079a1a3482fd.pdf
	dtask.addEventListener("statechanged",
		function(task, status) {
			if(!dtask) {
				return;
			}
			switch(task.state) {
				case 1: // 开始
					mui.toast("开始下载...");
					break;
				case 2: // 已连接到服务器
					mui.toast("已连接到服务器");
					break;
				case 3: // 已接收到数据
					mui.toast("正在下载" + task.downloadedSize + "/" + task.totalSize);
					break;

				case 4: // 下载完成 
					console.log(4 + ":" + isopen + ":" + f);
					if(task.totalSize != 0) {
						console.log("下载完成！" + task.filename);
						mui.toast("下载完成！" + task.filename);
						if(isopen == true) {
							plus.runtime.openFile(task.filename, {},
								function(e) {
									console.log("无法打开此文件：" + e + ":" + e.emssage);
									mui.toast("无法打开此文件：" + e.emssage);
								});
						}
						//ClosedPage(task.filename);mui.toast
					} else {
						mui.toast("下载失败:请联系管理员检查服务器文件是否存在");
						//ClosedPage(''); 
					}
					break;
			}
		});
	dtask.start();
}

/*
根据〖中华人民共和国国家标准 GB 11643-1999〗中有关公民身份号码的规定，公民身份号码是特征组合码，由十七位数字本体码和一位数字校验码组成。排列顺序从左至右依次为：六位数字地址码，八位数字出生日期码，三位数字顺序码和一位数字校验码。
    地址码表示编码对象常住户口所在县(市、旗、区)的行政区划代码。
    出生日期码表示编码对象出生的年、月、日，其中年份用四位数字表示，年、月、日之间不用分隔符。
    顺序码表示同一地址码所标识的区域范围内，对同年、月、日出生的人员编定的顺序号。顺序码的奇数分给男性，偶数分给女性。
    校验码是根据前面十七位数字码，按照ISO 7064:1983.MOD 11-2校验码计算出来的检验码。

出生日期计算方法。
    15位的身份证编码首先把出生年扩展为4位，简单的就是增加一个19或18,这样就包含了所有1800-1999年出生的人;
    2000年后出生的肯定都是18位的了没有这个烦恼，至于1800年前出生的,那啥那时应该还没身份证号这个东东，⊙﹏⊙b汗...
下面是正则表达式:
 出生日期1800-2099  (18|19|20)?\d{2}(0[1-9]|1[12])(0[1-9]|[12]\d|3[01])
 身份证正则表达式 /^\d{6}(18|19|20)?\d{2}(0[1-9]|1[12])(0[1-9]|[12]\d|3[01])\d{3}(\d|X)$/i            
 15位校验规则 6位地址编码+6位出生日期+3位顺序号
 18位校验规则 6位地址编码+8位出生日期+3位顺序号+1位校验位
 
 校验位规则     公式:∑(ai×Wi)(mod 11)……………………………………(1)
                公式(1)中： 
                i----表示号码字符从由至左包括校验码在内的位置序号； 
                ai----表示第i位置上的号码字符值； 
                Wi----示第i位置上的加权因子，其数值依据公式Wi=2^(n-1）(mod 11)计算得出。
                i 18 17 16 15 14 13 12 11 10 9 8 7 6 5 4 3 2 1
                Wi 7 9 10 5 8 4 2 1 6 3 7 9 10 5 8 4 2 1

*/
//身份证号合法性验证 
//支持15位和18位身份证号
//支持地址编码、出生日期、校验位验证
function IdentityCodeValid(code) {
	//	console.log("aaa");
	var city = {
		11: "北京",
		12: "天津",
		13: "河北",
		14: "山西",
		15: "内蒙古",
		21: "辽宁",
		22: "吉林",
		23: "黑龙江 ",
		31: "上海",
		32: "江苏",
		33: "浙江",
		34: "安徽",
		35: "福建",
		36: "江西",
		37: "山东",
		41: "河南",
		42: "湖北 ",
		43: "湖南",
		44: "广东",
		45: "广西",
		46: "海南",
		50: "重庆",
		51: "四川",
		52: "贵州",
		53: "云南",
		54: "西藏 ",
		61: "陕西",
		62: "甘肃",
		63: "青海",
		64: "宁夏",
		65: "新疆",
		71: "台湾",
		81: "香港",
		82: "澳门",
		91: "国外 "
	};
	var tip = "";
	var pass = true;
	if(!code || !/^\d{6}(18|19|20)?\d{2}(0[1-9]|1[012])(0[1-9]|[12]\d|3[01])\d{3}(\d|[xX])$/.test(code)) {
		tip = "身份证号格式错误";
		pass = false;
	} else if(!city[code.substr(0, 2)]) {
		console.log(2)
		//tip = "地址编码错误";
		tip = "请输入正确的身份证号！";
		pass = false;
	} else {
		//18位身份证需要验证最后一位校验位
		if(code.length == 19) {
			console.log(3)
			code = code.split('');
			//∑(ai×Wi)(mod 11)
			//加权因子
			var factor = [7, 9, 10, 5, 8, 4, 2, 1, 6, 3, 7, 9, 10, 5, 8, 4, 2];
			//校验位
			var parity = [1, 0, 'X', 9, 8, 7, 6, 5, 4, 3, 2];
			var sum = 0;
			var ai = 0;
			var wi = 0;
			for(var i = 0; i < 17; i++) {
				ai = code[i];
				wi = factor[i];
				sum += ai * wi;
			}

			if(parity[sum % 11] != code[17].toUpperCase()) {
				//              tip = "校验位错误";
				tip = "请输入正确的身份证号！";
				pass = false;
			}
		}
	}
	if(!pass) mui.toast(tip);
	return pass;
}

/*
 * 得到连接网络状态
 */
function getconnectionstate() {
	//判断网络连接
	if(plus.networkinfo.getCurrentType() == plus.networkinfo.CONNECTION_NONE) {
		return false;
	}

	return true;
}

function getNowFormatDate() {
	var date = new Date();
	var seperator1 = "-";
	var seperator2 = ":";
	var month = date.getMonth() + 1;
	var strDate = date.getDate();
	if(month >= 1 && month <= 9) {
		month = "0" + month;
	}
	if(strDate >= 0 && strDate <= 9) {
		strDate = "0" + strDate;
	}
	var currentdate = date.getFullYear() + seperator1 + month + seperator1 + strDate +
		" " + date.getHours() + seperator2 + date.getMinutes() +
		seperator2 + date.getSeconds();
	return currentdate;
}
var wp;
/*
 * 打开新的窗体
 */
var intervalnum = true;

function animateWindow(geturl, data) {
	if(intervalnum == false) {
		return;
	}
	intervalnum = false;
	setTimeout(function() {
		intervalnum = true;
	}, 300)
	if(mui.os.plus) {
		var subwaiting = plus.nativeUI.showWaiting(); //显示原生等待框
		var curUrl = geturl;
		var self = plus.webview.currentWebview();
		wp = plus.webview.create(curUrl, geturl, {
			scrollIndicator: 'none',
			scalable: false,
			popGesture: 'none'
		}, data);
		wp.addEventListener("loaded", function() {
			subwaiting.close();
			wp.show('slide-in-right');
		}, false);
	} else {
		var data = {

		};
		mui.openWindow({
			url: geturl + "?pagedata=" + escape(JSON.stringify(data)),
			id: geturl
		});
	}
}
/**
 2  * 检查银行卡号是否符合规则
 3  * @param bankno 银行卡号
 4  * @returns
 5  */

function checkBankNo(bankno) {
	var bankno = bankno.replace(/\s/g, '');
	if(bankno == "") {
		mui.toast("请填写银行卡号");
		return false;
	}
	if(bankno.length < 16 || bankno.length > 19) {
		mui.toast("银行卡号长度必须在16到19之间");
		return false;
	}
	var num = /^\d*$/; // 全数字
	if(!num.exec(bankno)) {
		mui.toast("银行卡号必须全为数字");
		return false;
		// 开头两位
		var strBin = "10,18,30,35,37,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,58,60,62,65,68,69,84,87,88,94,95,98,99";
		if(strBin.indexOf(bankno.substring(0, 2)) == -1) {
			mui.toast("银行卡号开头两位不符合规范");
			return false;
		}
		// luhn校验
		if(!luhnCheck(bankno)) {
			return false;
		}

	}
	return true;
}

function getNation() {
	var data = [{
			id: "01",
			text: "汉族"
		}, {
			id: "02",
			text: "蒙古族"
		}, {
			id: "03",
			text: "回族"
		},
		{
			id: "04",
			text: "藏族"
		}, {
			id: "05",
			text: "维吾尔族"
		}, {
			id: "06",
			text: "苗族"
		},
		{
			id: "07",
			text: "彝族"
		}, {
			id: "08",
			text: "壮族"
		}, {
			id: "09",
			text: "布依族"
		},
		{
			id: "10",
			text: "朝鲜族"
		}, {
			id: "11",
			text: "满族"
		}, {
			id: "12",
			text: "侗族"
		},
		{
			id: "13",
			text: "瑶族"
		}, {
			id: "14",
			text: "白族"
		}, {
			id: "15",
			text: "土家族"
		},
		{
			id: "16",
			text: "哈尼族"
		}, {
			id: "17",
			text: "哈萨克族"
		}, {
			id: "18",
			text: "傣族"
		},
		{
			id: "19",
			text: "黎族"
		}, {
			id: "20",
			text: "傈僳族"
		}, {
			id: "21",
			text: "佤族"
		},
		{
			id: "22",
			text: "畲族"
		}, {
			id: "23",
			text: "高山族"
		}, {
			id: "24",
			text: "拉祜族"
		},
		{
			id: "25",
			text: "水族"
		}, {
			id: "26",
			text: "东乡族"
		}, {
			id: "27",
			text: "纳西族"
		},
		{
			id: "28",
			text: "景颇族"
		}, {
			id: "29",
			text: "柯尔克孜族"
		}, {
			id: "30",
			text: "土族"
		},
		{
			id: "31",
			text: "达斡尔族"
		}, {
			id: "32",
			text: "仫佬族"
		}, {
			id: "33",
			text: "羌族"
		},
		{
			id: "34",
			text: "布朗族"
		}, {
			id: "35",
			text: "撒拉族"
		}, {
			id: "36",
			text: "毛难族"
		},
		{
			id: "37",
			text: "仡佬族"
		}, {
			id: "38",
			text: "锡伯族"
		}, {
			id: "39",
			text: "阿昌族"
		},
		{
			id: "40",
			text: "普米族"
		}, {
			id: "41",
			text: "塔吉克族"
		}, {
			id: "42",
			text: "怒族"
		},
		{
			id: "43",
			text: "乌孜别克族"
		}, {
			id: "44",
			text: "俄罗斯族"
		}, {
			id: "45",
			text: "鄂温克族"
		},
		{
			id: "46",
			text: "崩龙族"
		}, {
			id: "47",
			text: "保安族"
		}, {
			id: "48",
			text: "裕固族"
		},
		{
			id: "49",
			text: "京族"
		}, {
			id: "50",
			text: "塔塔尔族"
		}, {
			id: "51",
			text: "独龙族"
		},
		{
			id: "52",
			text: "鄂伦春族"
		}, {
			id: "53",
			text: "赫哲族"
		}, {
			id: "54",
			text: "门巴族"
		},
		{
			id: "55",
			text: "珞巴族"
		}, {
			id: "56",
			text: "基诺族"
		}
	];

	return data;
}

function getTabList(ids, data) {

	var userPicker = new mui.PopPicker();
	userPicker.setData(data);
	var showUserPickerButton = ids;
	showUserPickerButton.addEventListener('tap', function(event) {
		userPicker.show(function(items) {
			showUserPickerButton.value = items[0].text;
			//返回 false 可以阻止选择框的关闭
			//return false;

		});
	}, false);
}

function getTabLists(ids, data, callback) {
	var userPicker = new mui.PopPicker();
	userPicker.setData(data);
	var showUserPickerButton = ids;
	showUserPickerButton.addEventListener('tap', function(event) {
		userPicker.show(function(items) {
			showUserPickerButton.value = items[0].text;
			//返回 false 可以阻止选择框的关闭
			//return false;
			return callback(items[0].id, items[0].text);
		});
	}, false);
}

function validatemobile(mobile) {

	if(mobile.length == 0) {
		mui.toast('请输入手机号码！');
		return false;
	}
	if(mobile.length != 11) {
		mui.toast('请输入有效的手机号码！');
		return false;
	}

	var myreg = /(^1[3|4|5|7|8]\d{9}$)|(^09\d{8}$)/;
	if(!myreg.test(mobile)) {
		mui.toast('请输入有效的手机号码！');
		return false;
	}
	return true;
}

function getIdDetail(state, callback) {

	var url = localStorage.getItem("basicsip");
	url = url + "machine-user/view";
	mui.ajax(url, {
		dataType: 'JSONP', //服务器返回json 格式数据      
		type: 'get', //HTTP请求类型    
		headers: {
			'Authorization': 'Bearer ' + state.token
		},
		timeout: 5000, //超时时间设置为10秒；    
		success: function(data) {
			var arr = JSON.parse(data);
			if(arr.code == 200) {
				//获个人信息 并储存
				state.name = arr.data.name ? arr.data.name : ""; //姓名
				state.phone = arr.data.phone ? arr.data.phone : ""; //联系电话
				state.gende = arr.data.sex ? arr.data.sex : ""; //性别
				state.nation = arr.data.nation ? arr.data.nation : ""; //民族
				state.address = arr.data.city ? arr.data.city : ""; //居住地址
				state.identify = arr.data.id_card ? arr.data.id_card : ""; //身份证号
				state.is_identity = arr.data.is_identity ? arr.data.is_identity : ""; //实名
				state.header_image = arr.data.header_image ? arr.data.header_image : ""; //头像
				state.examine = arr.data.examine ? arr.data.examine : ""; //身份是否審核通過
				//获取种植信息
				app.setState(state);
				return callback("200");
			}
		},
		error: function(xhr, type, errorThrown) {

			console.log('获取数据失败:' + type + ':' + errorThrown + ':' + xhr);
		}
	});

}

function getlocalStorage(state) {

	var url = localStorage.getItem("basicsip");
	url = url + "cotton-farmers/detail";
	mui.ajax(url, {
		dataType: 'JSONP', //服务器返回json 格式数据      
		type: 'get', //HTTP请求类型    
		headers: {
			'Authorization': 'Bearer ' + state.token
		},
		timeout: 5000, //超时时间设置为10秒；    
		success: function(data) {
			var arr = JSON.parse(data);
			console.log(data);
			if(arr.code == 200) {
				//获个人信息 并储存

				state.name = arr.data.username; //姓名
				state.phone = arr.data.mobile_phone; //联系电话
				state.gende = arr.data.gende; //性别
				state.nation = arr.data.nation; //民族
				state.address = arr.data.address; //居住地址
				state.identify = arr.data.id_code; //身份证号
				state.postcode = arr.data.postcode; //邮编
				state.is_identity = arr.data.is_identity; //实名

				//或许种植信息

				state.crop_name = arr.data.crop_name; //作物名称
				state.cotton_area = arr.data.cotton_area; //种植面积
				state.average = arr.data.average; //平均产量
				state.plot_number = arr.data.plot_number; //地块数量
				state.three_insurance = arr.data.three_insurance; //保险情况
				state.area_type = arr.data.area_type; //兵團情况
				state.information = arr.data.plant_info; //地块信息json
				state.plant_area = arr.data.plant_area; //种植地址
				state.area_type = arr.data.area_type //地区判断
				if(arr.data.area_type == 1) {
					state.area_code1x = arr.data.division;
					state.area_code2x = arr.data.group;
					state.area_code3x = arr.data.even;
				} else if(arr.data.area_type == 2) {
					state.area_code1x = arr.data.province;
					state.area_code2x = arr.data.city;
					state.area_code3x = arr.data.county;
				}

				state.imgurl = arr.data.avatar;
				state.bank_card = arr.data.bank_card;
				app.setState(state);
			}
		},
		error: function(xhr, type, errorThrown) {

			console.log('获取数据失败:' + type + ':' + errorThrown + ':' + xhr);
		}
	});
}

function getlocalStorageinformation(state) {

	var url = localStorage.getItem("basicsip");
	url = url + "cotton-farmers/detail";
	mui.ajax(url, {
		dataType: 'JSONP', //服务器返回json 格式数据      
		type: 'get', //HTTP请求类型    
		headers: {
			'Authorization': 'Bearer ' + state.token
		},
		timeout: 5000, //超时时间设置为10秒；    
		success: function(data) {
			var arr = JSON.parse(data);
			console.log(data);
			if(arr.code == 200) {
				//获个人信息 并储存
				if(arr.data.area_type == 1) {
					state.area_code1x = arr.data.division;
					state.area_code2x = arr.data.group;
					state.area_code3x = arr.data.even;
				} else if(arr.data.area_type == 2) {
					state.area_code1x = arr.data.province;
					state.area_code2x = arr.data.city;
					state.area_code3x = arr.data.county;
				}
				state.information = arr.data.plant_info; //地块信息json
				//或许种植信息					
				app.setState(state);
			}
		},
		error: function(xhr, type, errorThrown) {

			console.log('获取数据失败:' + type + ':' + errorThrown + ':' + xhr);
		}
	});

}

function GetDateDiff(startTime, endTime, diffType) {
	//将xxxx-xx-xx的时间格式，转换为 xxxx/xx/xx的格式 
	//startTime = startTime.replace(/\-/g, "/");
	endTime = endTime.replace(/\-/g, "/");
	//将计算间隔类性字符转换为小写
	diffType = diffType.toLowerCase();
	var sTime = new Date(startTime); //开始时间
	var eTime = new Date(endTime); //结束时间
	//作为除数的数字
	var timeType = 1;
	switch(diffType) {
		case "second":
			timeType = 1000;
			break;
		case "minute":
			timeType = 1000 * 60;
			break;
		case "hour":
			timeType = 1000 * 3600;
			break;
		case "day":
			timeType = 1000 * 3600 * 24;
			break;
		default:
			break;
	}
	return parseInt((eTime.getTime() - sTime.getTime()) / parseInt(timeType));
}

(function($, owner) {
	owner.getAjaxQuery = function(url_ip, token, type, datas, callback) {
		callback = callback || $.noop;
		var url = localStorage.getItem("basicsip") + url_ip;
		$.ajax({
			type: type,
			url: url,
			dataType: 'jsonp',
			data: datas,
			headers: {
				'Authorization': 'Bearer ' + token
			},
			success: function(data) {
				var arr = JSON.parse(data);

				if(arr.code == 401) {
					getLogoFf();
					return;
				}
				return callback(arr);
			},
			error: function(xhr, type, errorThrown) {
				console.log('登录错误:' + type + ':' + errorThrown + ':' + xhr);
				mui.toast("网络连接失败");

				if(plus.nativeUI.showWaiting()) {
					plus.nativeUI.closeWaiting()

				}

				return callback("0");
			}
		});
	};
	/*
	 * 非token请求
	 */
	owner.getAjaxPhone = function(url_ip, type, datas, callback) {
		callback = callback || $.noop;
		var url = localStorage.getItem("basicsip") + url_ip;
		$.ajax({
			type: type,
			url: url,
			dataType: 'jsonp',
			data: datas,
			success: function(data) {
				var arr = JSON.parse(data);
				if(arr.code == 401) {
					getLogoFf();
					return;
				}
				return callback(arr);
			},
			error: function(xhr, type, errorThrown) {
				console.log('登录错误:' + type + ':' + errorThrown + ':' + xhr);
				mui.toast("网络连接失败");
				return callback("0");
			}
		});
	};
	/*
	 * 分页加载通用
	 */
	owner.getPullAjaxQuery = function(url_ip, token, type, datas, callback) {
		var arr;
		var num;
		callback = callback || $.noop;
		var url = localStorage.getItem("basicsip") + url_ip;
		$.ajax({
			type: type,
			url: url,
			dataType: 'jsonp',
			data: datas,
			headers: {
				'Authorization': 'Bearer ' + token
			},
			success: function(data) {

				arr = JSON.parse(data);
				if(arr.code == 401) {
					getLogoFf();
					return;
				}
			},
			complete: function(XHR, TS) {
				num = XHR.getResponseHeader("X-Pagination-Page-Count");
				return callback(arr, num);
			},
			error: function(xhr, type, errorThrown) {
				console.log('登录错误:' + type + ':' + errorThrown + ':' + xhr);
				mui.toast("暂无更多数据");
			}
		});
	};
	/*下拉刷新的*/
	owner.getPullAjaxDown = function(url_ip, token, type, datas, id, callback) {
		var arr;
		var num;
		callback = callback || $.noop;
		var url = localStorage.getItem("basicsip") + url_ip;


		$.ajax({
			type: type,
			url: url,
			dataType: 'jsonp',
			data: datas,
			headers: {
				'Authorization': 'Bearer ' + token
			},
			success: function(data) {
				//是否有关联用户
				arr = JSON.parse(data);
				id._id3.removeClass("visibilityhidden");
				id._id4.removeClass("visibilityhidden");
				mui('#pullrefresh').pullRefresh().endPulldownToRefresh();
				mui('#pullrefresh').pullRefresh().refresh(true);
				if(!arr.data || arr.data.length <= 0 || arr.code != 200) {
					id._id1.show();
					id._id2.show();
					mui('#pullrefresh').pullRefresh().endPullupToRefresh(true);
					id._id3.addClass("visibilityhidden");
					id._id4.addClass("visibilityhidden");
				} else {
					id._id1.hide();
					id._id2.hide();		
				}

				if(arr.code == 401) {
					getLogoFf();
					return callback(arr, 0);
				}
			},
			complete: function(XHR, TS) {
				num = XHR.getResponseHeader("X-Pagination-Page-Count");
				if(num == 1 || !num) {
					mui('#pullrefresh').pullRefresh().endPullupToRefresh(true);
					id._id3.addClass("visibilityhidden");
					id._id4.addClass("visibilityhidden");
				}
				return callback(arr, num);
			},
			error: function(xhr, type, errorThrown) {
				console.log('登录错误:' + type + ':' + errorThrown + ':' + xhr);
				mui('#pullrefresh').pullRefresh().endPulldownToRefresh();
				mui('#pullrefresh').pullRefresh().refresh(true);
				id._id1.show();
				id._id2.show();
				mui('#pullrefresh').pullRefresh().endPullupToRefresh(true);
				id._id3.addClass("visibilityhidden");
				id._id4.addClass("visibilityhidden");
				mui.toast("网络连接错误");

			}
		});
	};
	/*上拉加載 */
	owner.getPullAjaxUp = function(url_ip, token, type, datas, callback) {
		var arr;
		var num;
		callback = callback || $.noop;
		var url = localStorage.getItem("basicsip") + url_ip;
		$.ajax({
			type: type,
			url: url,
			dataType: 'jsonp',
			data: datas,
			headers: {
				'Authorization': 'Bearer ' + token
			},
			success: function(data) {
				//是否有关联用户
				arr = JSON.parse(data);
				if(arr.code == 401) {
					getLogoFf();
					return;
				}
			},
			complete: function(XHR, TS) {
				num = XHR.getResponseHeader("X-Pagination-Page-Count");
				return callback(arr, num);
			},
			error: function(xhr, type, errorThrown) {
				console.log('登录错误:' + type + ':' + errorThrown + ':' + xhr);
				mui.toast("暂无更多数据");
			}
		});
	};
	owner.getlocalStorageID = function(state, callback) {
		var url = localStorage.getItem("basicsip");
		url = url + "cotton-farmers/detail";
		mui.ajax(url, {
			dataType: 'JSONP', //服务器返回json 格式数据      
			type: 'get', //HTTP请求类型    
			headers: {
				'Authorization': 'Bearer ' + state.token
			},
			timeout: 5000, //超时时间设置为10秒；    
			success: function(data) {
				var arr = JSON.parse(data);
				if(arr.code == 200) {
					return callback(arr.data.is_identity);
				} else if(arr.code == 401) {
					getLogoFf();
					return;
				}
			},
			error: function(xhr, type, errorThrown) {
				console.log('获取数据失败:' + type + ':' + errorThrown + ':' + xhr);
				return callback("网络连接失败");
			}
		});
	}
	/*修改头像*/
	owner.getHeadeImg = function(id, callback) {

		if(!mui.os.plus) {

			return;
		} else {

			var btnArray = [{
				title: "拍照"
			}, {
				title: "从相册选择"
			}];
			plus.nativeUI.actionSheet({
				cancel: "取消",
				buttons: btnArray
			}, function(event) {
				var index = event.index;
				switch(index) {
					case 1:
						util.appendByCamera(id, function(arr) {
							return callback(arr);
						});
						break;
					case 2:
						util.appendByGallery(id, function(arr) {
							return callback(arr);
						});
						break;
				}
			});
		}

	}

	// 拍照添加文件
	owner.appendByCamera = function(id, callback) {
		var cmr = plus.camera.getCamera();
		var base64 = "";
		cmr.captureImage(function(p) {

			//转化 文件格式
			plus.io.resolveLocalFileSystemURL(p, function(entry) {
				var imgurl = entry.toLocalURL();
				util.compressImage(imgurl, function(imgs) {

					var image = new Image();
					id.src = imgs;
					image.src = imgs;
					image.onload = function() {
						base64 = getBase64Image(image);
						return callback(base64);

					}

				})

			}, function(e) {
				console.log('读取拍照文件错误：' + e.message);
			});
		}, function(e) {
			console.log('失败：' + e.message);
		}, {
			filename: '_doc/camera/',
			index: 1
		});
	}

	// 从相册添加文件
	owner.appendByGallery = function(id, callback) {
		plus.gallery.pick(function(p) {
			util.compressImage(p, function(imgs) {

				var base64 = "";
				id.src = imgs;
				var image = new Image();

				image.src = imgs;
				image.onload = function() {
					base64 = util.getBase64Image(image);
					return callback(base64);
				}

			})
		})
	}

	owner.getBase64Image = function(img) {
		var canvas = document.createElement("canvas");
		canvas.width = img.width;
		canvas.height = img.height;
		var ctx = canvas.getContext("2d");
		ctx.drawImage(img, 0, 0, img.width, img.height);
		var ext = img.src.substring(img.src.lastIndexOf(".") + 1).toLowerCase();
		var dataURL = canvas.toDataURL("image/" + ext);
		return dataURL;
	}

	// 压缩图片
	owner.compressImage = function(img, callback) {
		var times = getDataTime1();
		plus.nativeUI.showWaiting();
		plus.zip.compressImage({
				src: img,
				dst: "_doc/" + times + "cm.jpg",
				quality: 20,
				overwrite: true,
				width: '30%'

			},
			function(i) {
				plus.nativeUI.closeWaiting();

				return callback(i.target);

			},
			function(e) {
				plus.nativeUI.closeWaiting();
				mui.toast("您的图片过大");
			});
	}

}(mui, window.util = {}));

function getLogoFf() {
	switch(plus.os.name) {
		case "iOS":
			plus.ios.importClass("WebAppController").getText("logoff");
			break;
		case "Android":
			var appInterface = plus.android.newObject("com.lianhuawang.SDK_WebApp");
			plus.android.invoke(appInterface, "logoff");
			break;
		default:
			// 其它平台
			break;

	}
}


/*
 * 获取当前时间
 */
function getNowFormatDate() {
	var date = new Date();
	var seperator1 = "-";
	var seperator2 = ":";
	var month = date.getMonth() + 1;
	var strDate = date.getDate();
	if(month >= 1 && month <= 9) {
		month = "0" + month;
	}
	if(strDate >= 0 && strDate <= 9) {
		strDate = "0" + strDate;
	}
	var currentdate = date.getFullYear() + seperator1 + month + seperator1 + strDate +
		" " + date.getHours() + seperator2 + date.getMinutes() +
		seperator2 + date.getSeconds();
	return currentdate;
}
//时间格式转化
function getDataTime(time) {
	var date = new Date(time);
	var time1 = date.getTime() / 1000;
	return time1;
}

function getDataTime1() {
	var date = new Date();
	var time1 = date.getTime() / 1000;
	return time1;
}

function getnewDate(time) {
	var date = new Date();
	date.setTime(time * 1000);
	return date.Format('yyyy-MM-dd');
}

function getCropsSkill(state) {
	util.getAjaxQuery("machine-user/crops-skill", state.token, "get", "", function(arr) {
		if(arr.code == 200) {
			if(arr.data.crops[0]) {
				state.crop_name = arr.data.crops[0].crops_id.text;
				state.name_id = arr.data.crops[0].crops_id.crops_id;
			}

			state.jsn = [];
			if(arr.data.skill) {
				for(var i = 0; i < arr.data.skill.length; i++) {
					state.jsn[i] = arr.data.skill[i].skill_id.skill_id
				}
			}
			app.setState(state);
		}
	})
}